Scriptname POSSMcmScr extends ski_configbase 

POSSMainScr Property MainScr Auto

Int Property ModifierKey = 42 Auto Hidden ; Left shift
Int Property ToolKey = 35 Auto Hidden ; H
Int Property ToolActorListKey = 35 Auto Hidden ; H
Int Property ToolsOnlyKey = 0 Auto Hidden
Int Property CumOutsideKey = 0 Auto Hidden
Int Property ChangeStageKey = 0 Auto Hidden
Int Property QueueKey = 0 Auto Hidden

Bool AutoFollowPlayer = True
Bool Function AutoFollowPlayer()
	Return AutoFollowPlayer
EndFunction
Bool AutoFollowReceiver = True
Bool Function AutoFollowReceiver()
	Return AutoFollowReceiver
EndFunction

Int Function GetVersion()
	Return 30
EndFunction
Event OnVersionUpdate(Int NewVersion)
;	Debug.Trace("POSS OnVersionUpdate - CurrentVersion - "+CurrentVersion+" / NewVersion - "+NewVersion)
	If ((NewVersion > 20) && (CurrentVersion != 0))
		MainScr.Maintenance(True, NewVersion)
	Endif
EndEvent

Event OnConfigInit()
	Pages = New String[2] 
	Pages[0] = "$Settings"
	Pages[1] = "$Animation creator"
	MainScr.Install()
	MainScr.Maintenance()
EndEvent
Event OnGameReload()
	If (CurrentVersion != 0)
		MainScr.Maintenance()
	Endif
	parent.OnGameReload()
EndEvent

Event OnPageReset(String page)
	If (Page == "")
		LoadCustomContent("SLTools/SLToolsLogo.dds", 175, 30)
		Return
	Else
		UnloadCustomContent()
	Endif
	If (Page == "$Settings")
		SetCursorFillMode(TOP_TO_BOTTOM)
		AddHeaderOption("$System")
		AddTextOptionST("SystemReconfigure", "$Reconfigure", "$Click")

		AddHeaderOption("$Main hotkeys")
		AddKeyMapOptionST("ModifierKey", "$Modifier key", ModifierKey)
		AddKeyMapOptionST("ToolKey", "$Tool key", ToolKey)
		AddKeyMapOptionST("ToolActorListKey", "$Tool actor list key", ToolActorListKey)
		AddEmptyOption()

		AddHeaderOption("$Matchmaker queue")
		AddKeyMapOptionST("QueueKey", "$Matchmaker queue key", QueueKey)

		AddToggleOptionST("QueueAutoFollowPlayer", "$Auto follow player", AutoFollowPlayer)
		AddToggleOptionST("QueueAutoFollowReceiver", "$Auto follow receiver", AutoFollowReceiver)

		SetCursorPosition(1)
		AddTextOption("$SexLab Tools by Goubo // LoversLab.com", "v3")
		AddEmptyOption()

		AddHeaderOption("$Misc hotkeys")
		AddKeyMapOptionST("ChangeStageKey", "$Change stage key", ChangeStageKey)
		AddKeyMapOptionST("ToolsOnlyKey", "$Tools only key", ToolsOnlyKey)
		AddKeyMapOptionST("CumOutsideKey", "$Cum outside key", CumOutsideKey)
		AddEmptyOption()

		AddHeaderOption("$Animation unregisterer")
		AddTextOptionST("UnregisterAnimation", "$Unregister animation", "$Click")


	Elseif (Page == "$Animation creator")
		SetCursorFillMode(TOP_TO_BOTTOM)

		AddTextOptionST("CustomAnimName", "$Animation name", MainScr.CustomAnimGetName())
		AddTextOptionST("CustomAnimRace", "$Set race", MainScr.CustomAnimGetRace())
		AddTextOptionST("CustomAnimType", "$Set type", MainScr.CustomAnimGetType())
		AddTextOptionST("CustomAnimActorsNumber", "$Set number of actors", MainScr.CustomAnimGetActorsNumber())
		AddTextOptionST("CustomAnimFilter", "$Set animation filter", MainScr.CustomAnimGetFilter())
		AddEmptyOption()

		AddTextOptionST("CustomAnimS1", "$Stage 1", MainScr.CustomAnimGetStage(0))
		AddTextOptionST("CustomAnimSub1", "$Stage of the chosen animation", MainScr.CustomAnimGetSubStage(0))
		AddTextOptionST("CustomAnimST1", "$Stage timer", MainScr.CustomAnimGetStageTimer(0))

		AddTextOptionST("CustomAnimS2", "$Stage 2", MainScr.CustomAnimGetStage(1))
		AddTextOptionST("CustomAnimSub2", "$Stage of the chosen animation", MainScr.CustomAnimGetSubStage(1))
		AddTextOptionST("CustomAnimST2", "$Stage timer", MainScr.CustomAnimGetStageTimer(1))

		AddTextOptionST("CustomAnimS3", "$Stage 3", MainScr.CustomAnimGetStage(2))
		AddTextOptionST("CustomAnimSub3", "$Stage of the chosen animation", MainScr.CustomAnimGetSubStage(2))
		AddTextOptionST("CustomAnimST3", "$Stage timer", MainScr.CustomAnimGetStageTimer(2))

		AddTextOptionST("CustomAnimS4", "$Stage 4", MainScr.CustomAnimGetStage(3))
		AddTextOptionST("CustomAnimSub4", "$Stage of the chosen animation", MainScr.CustomAnimGetSubStage(3))
		AddTextOptionST("CustomAnimST4", "$Stage timer", MainScr.CustomAnimGetStageTimer(3))

		AddTextOptionST("CustomAnimS5", "$Stage 5", MainScr.CustomAnimGetStage(4))
		AddTextOptionST("CustomAnimSub5", "$Stage of the chosen animation", MainScr.CustomAnimGetSubStage(4))
		AddTextOptionST("CustomAnimST5", "$Stage timer", MainScr.CustomAnimGetStageTimer(4))

		AddTextOptionST("CustomAnimS6", "$Stage 6", MainScr.CustomAnimGetStage(5))
		AddTextOptionST("CustomAnimSub6", "$Stage of the chosen animation", MainScr.CustomAnimGetSubStage(5))
		AddTextOptionST("CustomAnimST6", "$Stage timer", MainScr.CustomAnimGetStageTimer(5))

		AddTextOptionST("CustomAnimS7", "$Stage 7", MainScr.CustomAnimGetStage(6))
		AddTextOptionST("CustomAnimSub7", "$Stage of the chosen animation", MainScr.CustomAnimGetSubStage(6))
		AddTextOptionST("CustomAnimST7", "$Stage timer", MainScr.CustomAnimGetStageTimer(6))

		AddTextOptionST("CustomAnimS8", "$Stage 8", MainScr.CustomAnimGetStage(7))
		AddTextOptionST("CustomAnimSub8", "$Stage of the chosen animation", MainScr.CustomAnimGetSubStage(7))
		AddTextOptionST("CustomAnimST8", "$Stage timer", MainScr.CustomAnimGetStageTimer(7))

		AddTextOptionST("CustomAnimS9", "$Stage 9", MainScr.CustomAnimGetStage(8))
		AddTextOptionST("CustomAnimSub9", "$Stage of the chosen animation", MainScr.CustomAnimGetSubStage(8))
		AddTextOptionST("CustomAnimST9", "$Stage timer", MainScr.CustomAnimGetStageTimer(8))

		AddTextOptionST("CustomAnimS10", "$Stage 10", MainScr.CustomAnimGetStage(9))
		AddTextOptionST("CustomAnimSub10", "$Stage of the chosen animation", MainScr.CustomAnimGetSubStage(9))
		AddTextOptionST("CustomAnimST10", "$Stage timer", MainScr.CustomAnimGetStageTimer(9))

		SetCursorPosition(1)

		AddTextOptionST("RegisterAnim", "$Register to SexLab", "$Register")
		AddTextOptionST("CustomAnimReset", "$Reset animation", "$Reset")
		AddEmptyOption()
		AddEmptyOption()
		AddTextOptionST("CustomAnimFilterRemove", "$Remove animation filter", "$Click")

		AddEmptyOption()

		AddTextOptionST("CustomAnimStageRemove1", "$Remove stage", "$Click")
		AddEmptyOption()
		AddEmptyOption()
		AddTextOptionST("CustomAnimStageRemove2", "$Remove stage", "$Click")
		AddEmptyOption()
		AddEmptyOption()
		AddTextOptionST("CustomAnimStageRemove3", "$Remove stage", "$Click")
		AddEmptyOption()
		AddEmptyOption()
		AddTextOptionST("CustomAnimStageRemove4", "$Remove stage", "$Click")
		AddEmptyOption()
		AddEmptyOption()
		AddTextOptionST("CustomAnimStageRemove5", "$Remove stage", "$Click")
		AddEmptyOption()
		AddEmptyOption()
		AddTextOptionST("CustomAnimStageRemove6", "$Remove stage", "$Click")
		AddEmptyOption()
		AddEmptyOption()
		AddTextOptionST("CustomAnimStageRemove7", "$Remove stage", "$Click")
		AddEmptyOption()
		AddEmptyOption()
		AddTextOptionST("CustomAnimStageRemove8", "$Remove stage", "$Click")
		AddEmptyOption()
		AddEmptyOption()
		AddTextOptionST("CustomAnimStageRemove9", "$Remove stage", "$Click")
		AddEmptyOption()
		AddEmptyOption()
		AddTextOptionST("CustomAnimStageRemove10", "$Remove stage", "$Click")
		AddEmptyOption()
		AddEmptyOption()

	Endif
EndEvent

State RegisterAnim
	Event OnSelectST()
		If MainScr.CustomAnimationRegister()
			ShowMessage("$Animation registered", False)
		Else
			ShowMessage("$Animation not valid, already exists?", False)
		Endif
	EndEvent
	Event OnHighlightST()
		SetInfoText("$Desc_SLTCARegister")
	EndEvent
EndState
State CustomAnimReset
	Event OnSelectST()
		MainScr.CustomAnimReset()
		ShowMessage("$Animation reset", False)
		ForcePageReset()
	EndEvent
	Event OnHighlightST()
		SetInfoText("$Desc_SLTCAReset")
	EndEvent
EndState
State CustomAnimName
	Event OnSelectST()
		If MainScr.CustomAnimSetName()
			ForcePageReset()
		Endif
	EndEvent
	Event OnHighlightST()
		SetInfoText("$Desc_SLTCAName")
	EndEvent
EndState
State CustomAnimRace
	Event OnSelectST()
		If MainScr.CustomAnimSetRace()
			ForcePageReset()
		Else
			ShowMessage("$You can't change this if there is at least one stage set", False)
		Endif
	EndEvent
	Event OnHighlightST()
		SetInfoText("$Desc_SLTCARace")
	EndEvent
EndState
State CustomAnimType
	Event OnSelectST()
		MainScr.CustomAnimSetType()
		ForcePageReset()
	EndEvent
	Event OnHighlightST()
		SetInfoText("$Desc_SLTCAType")
	EndEvent
EndState
State CustomAnimActorsNumber
	Event OnSelectST()
		If MainScr.CustomAnimSetActorsNumber()
			ForcePageReset()
		Else
			ShowMessage("$You can't change this if there is at least one stage set", False)
		Endif
	EndEvent
	Event OnHighlightST()
		SetInfoText("$Desc_SLTCAActorsNumber")
	EndEvent
EndState
State CustomAnimFilter
	Event OnSelectST()
		If MainScr.CustomAnimSetFilter()
			ForcePageReset()
		Endif
	EndEvent
	Event OnHighlightST()
		SetInfoText("$Desc_SLTCAFilter")
	EndEvent
EndState
State CustomAnimFilterRemove
	Event OnSelectST()
		If MainScr.CustomAnimSetFilter(True)
			ForcePageReset()
		Endif
	EndEvent
EndState

State CustomAnimS1
	Event OnSelectST()
		Int Result = MainScr.CustomAnimSetStage(0)
		CustomAnimErrorMessageSetStage(Result)
	EndEvent
	Event OnHighlightST()
		SetInfoText("$Desc_SLTCAS")
	EndEvent
EndState
State CustomAnimSub1
	Event OnSelectST()
		If MainScr.CustomAnimSetSubStage(0)
			ForcePageReset()
		Else
			ShowMessage("$The corresponding animation for this stage need to be set before", False)
		Endif
	EndEvent
	Event OnHighlightST()
		SetInfoText("$Desc_SLTCASub")
	EndEvent
EndState
State CustomAnimST1
	Event OnSelectST()
		If MainScr.CustomAnimSetStageTimer(0)
			ForcePageReset()
		Else
			ShowMessage("$The corresponding animation for this stage need to be set before", False)
		Endif
	EndEvent
	Event OnHighlightST()
		SetInfoText("$Desc_SLTCAST")
	EndEvent
EndState
State CustomAnimStageRemove1
	Event OnSelectST()
		If MainScr.CustomAnimStageRemove(0)
			ForcePageReset()
		Else
			ShowMessage("$You can only remove the last stage", False)
		Endif
	EndEvent
EndState


State CustomAnimS2
	Event OnSelectST()
		Int Result = MainScr.CustomAnimSetStage(1)
		CustomAnimErrorMessageSetStage(Result)
	EndEvent
	Event OnHighlightST()
		SetInfoText("$Desc_SLTCAS")
	EndEvent
EndState
State CustomAnimSub2
	Event OnSelectST()
		If MainScr.CustomAnimSetSubStage(1)
			ForcePageReset()
		Else
			ShowMessage("$The corresponding animation for this stage need to be set before", False)
		Endif
	EndEvent
	Event OnHighlightST()
		SetInfoText("$Desc_SLTCASub")
	EndEvent
EndState
State CustomAnimST2
	Event OnSelectST()
		If MainScr.CustomAnimSetStageTimer(1)
			ForcePageReset()
		Else
			ShowMessage("$The corresponding animation for this stage need to be set before", False)
		Endif
	EndEvent
	Event OnHighlightST()
		SetInfoText("$Desc_SLTCAST")
	EndEvent
EndState
State CustomAnimStageRemove2
	Event OnSelectST()
		If MainScr.CustomAnimStageRemove(1)
			ForcePageReset()
		Else
			ShowMessage("$You can only remove the last stage", False)
		Endif
	EndEvent
EndState

State CustomAnimS3
	Event OnSelectST()
		Int Result = MainScr.CustomAnimSetStage(2)
		CustomAnimErrorMessageSetStage(Result)
	EndEvent
	Event OnHighlightST()
		SetInfoText("$Desc_SLTCAS")
	EndEvent
EndState
State CustomAnimSub3
	Event OnSelectST()
		If MainScr.CustomAnimSetSubStage(2)
			ForcePageReset()
		Else
			ShowMessage("$The corresponding animation for this stage need to be set before", False)
		Endif
	EndEvent
	Event OnHighlightST()
		SetInfoText("$Desc_SLTCASub")
	EndEvent
EndState
State CustomAnimST3
	Event OnSelectST()
		If MainScr.CustomAnimSetStageTimer(2)
			ForcePageReset()
		Else
			ShowMessage("$The corresponding animation for this stage need to be set before", False)
		Endif
	EndEvent
	Event OnHighlightST()
		SetInfoText("$Desc_SLTCAST")
	EndEvent
EndState
State CustomAnimStageRemove3
	Event OnSelectST()
		If MainScr.CustomAnimStageRemove(2)
			ForcePageReset()
		Else
			ShowMessage("$You can only remove the last stage", False)
		Endif
	EndEvent
EndState

State CustomAnimS4
	Event OnSelectST()
		Int Result = MainScr.CustomAnimSetStage(3)
		CustomAnimErrorMessageSetStage(Result)
	EndEvent
	Event OnHighlightST()
		SetInfoText("$Desc_SLTCAS")
	EndEvent
EndState
State CustomAnimSub4
	Event OnSelectST()
		If MainScr.CustomAnimSetSubStage(3)
			ForcePageReset()
		Else
			ShowMessage("$The corresponding animation for this stage need to be set before", False)
		Endif
	EndEvent
	Event OnHighlightST()
		SetInfoText("$Desc_SLTCASub")
	EndEvent
EndState
State CustomAnimST4
	Event OnSelectST()
		If MainScr.CustomAnimSetStageTimer(3)
			ForcePageReset()
		Else
			ShowMessage("$The corresponding animation for this stage need to be set before", False)
		Endif
	EndEvent
	Event OnHighlightST()
		SetInfoText("$Desc_SLTCAST")
	EndEvent
EndState
State CustomAnimStageRemove4
	Event OnSelectST()
		If MainScr.CustomAnimStageRemove(3)
			ForcePageReset()
		Else
			ShowMessage("$You can only remove the last stage", False)
		Endif
	EndEvent
EndState

State CustomAnimS5
	Event OnSelectST()
		Int Result = MainScr.CustomAnimSetStage(4)
		CustomAnimErrorMessageSetStage(Result)
	EndEvent
	Event OnHighlightST()
		SetInfoText("$Desc_SLTCAS")
	EndEvent
EndState
State CustomAnimSub5
	Event OnSelectST()
		If MainScr.CustomAnimSetSubStage(4)
			ForcePageReset()
		Else
			ShowMessage("$The corresponding animation for this stage need to be set before", False)
		Endif
	EndEvent
	Event OnHighlightST()
		SetInfoText("$Desc_SLTCASub")
	EndEvent
EndState
State CustomAnimST5
	Event OnSelectST()
		If MainScr.CustomAnimSetStageTimer(4)
			ForcePageReset()
		Else
			ShowMessage("$The corresponding animation for this stage need to be set before", False)
		Endif
	EndEvent
	Event OnHighlightST()
		SetInfoText("$Desc_SLTCAST")
	EndEvent
EndState
State CustomAnimStageRemove5
	Event OnSelectST()
		If MainScr.CustomAnimStageRemove(4)
			ForcePageReset()
		Else
			ShowMessage("$You can only remove the last stage", False)
		Endif
	EndEvent
EndState

State CustomAnimS6
	Event OnSelectST()
		Int Result = MainScr.CustomAnimSetStage(5)
		CustomAnimErrorMessageSetStage(Result)
	EndEvent
	Event OnHighlightST()
		SetInfoText("$Desc_SLTCAS")
	EndEvent
EndState
State CustomAnimSub6
	Event OnSelectST()
		If MainScr.CustomAnimSetSubStage(5)
			ForcePageReset()
		Else
			ShowMessage("$The corresponding animation for this stage need to be set before", False)
		Endif
	EndEvent
	Event OnHighlightST()
		SetInfoText("$Desc_SLTCASub")
	EndEvent
EndState
State CustomAnimST6
	Event OnSelectST()
		If MainScr.CustomAnimSetStageTimer(5)
			ForcePageReset()
		Else
			ShowMessage("$The corresponding animation for this stage need to be set before", False)
		Endif
	EndEvent
	Event OnHighlightST()
		SetInfoText("$Desc_SLTCAST")
	EndEvent
EndState
State CustomAnimStageRemove6
	Event OnSelectST()
		If MainScr.CustomAnimStageRemove(5)
			ForcePageReset()
		Else
			ShowMessage("$You can only remove the last stage", False)
		Endif
	EndEvent
EndState

State CustomAnimS7
	Event OnSelectST()
		Int Result = MainScr.CustomAnimSetStage(6)
		CustomAnimErrorMessageSetStage(Result)
	EndEvent
	Event OnHighlightST()
		SetInfoText("$Desc_SLTCAS")
	EndEvent
EndState
State CustomAnimSub7
	Event OnSelectST()
		If MainScr.CustomAnimSetSubStage(6)
			ForcePageReset()
		Else
			ShowMessage("$The corresponding animation for this stage need to be set before", False)
		Endif
	EndEvent
	Event OnHighlightST()
		SetInfoText("$Desc_SLTCASub")
	EndEvent
EndState
State CustomAnimST7
	Event OnSelectST()
		If MainScr.CustomAnimSetStageTimer(6)
			ForcePageReset()
		Else
			ShowMessage("$The corresponding animation for this stage need to be set before", False)
		Endif
	EndEvent
	Event OnHighlightST()
		SetInfoText("$Desc_SLTCAST")
	EndEvent
EndState
State CustomAnimStageRemove7
	Event OnSelectST()
		If MainScr.CustomAnimStageRemove(6)
			ForcePageReset()
		Else
			ShowMessage("$You can only remove the last stage", False)
		Endif
	EndEvent
EndState

State CustomAnimS8
	Event OnSelectST()
		Int Result = MainScr.CustomAnimSetStage(7)
		CustomAnimErrorMessageSetStage(Result)
	EndEvent
	Event OnHighlightST()
		SetInfoText("$Desc_SLTCAS")
	EndEvent
EndState
State CustomAnimSub8
	Event OnSelectST()
		If MainScr.CustomAnimSetSubStage(7)
			ForcePageReset()
		Else
			ShowMessage("$The corresponding animation for this stage need to be set before", False)
		Endif
	EndEvent
	Event OnHighlightST()
		SetInfoText("$Desc_SLTCASub")
	EndEvent
EndState
State CustomAnimST8
	Event OnSelectST()
		If MainScr.CustomAnimSetStageTimer(7)
			ForcePageReset()
		Else
			ShowMessage("$The corresponding animation for this stage need to be set before", False)
		Endif
	EndEvent
	Event OnHighlightST()
		SetInfoText("$Desc_SLTCAST")
	EndEvent
EndState
State CustomAnimStageRemove8
	Event OnSelectST()
		If MainScr.CustomAnimStageRemove(7)
			ForcePageReset()
		Else
			ShowMessage("$You can only remove the last stage", False)
		Endif
	EndEvent
EndState

State CustomAnimS9
	Event OnSelectST()
		Int Result = MainScr.CustomAnimSetStage(8)
		CustomAnimErrorMessageSetStage(Result)
	EndEvent
	Event OnHighlightST()
		SetInfoText("$Desc_SLTCAS")
	EndEvent
EndState
State CustomAnimSub9
	Event OnSelectST()
		If MainScr.CustomAnimSetSubStage(8)
			ForcePageReset()
		Else
			ShowMessage("$The corresponding animation for this stage need to be set before", False)
		Endif
	EndEvent
	Event OnHighlightST()
		SetInfoText("$Desc_SLTCASub")
	EndEvent
EndState
State CustomAnimST9
	Event OnSelectST()
		If MainScr.CustomAnimSetStageTimer(8)
			ForcePageReset()
		Else
			ShowMessage("$The corresponding animation for this stage need to be set before", False)
		Endif
	EndEvent
	Event OnHighlightST()
		SetInfoText("$Desc_SLTCAST")
	EndEvent
EndState
State CustomAnimStageRemove9
	Event OnSelectST()
		If MainScr.CustomAnimStageRemove(8)
			ForcePageReset()
		Else
			ShowMessage("$You can only remove the last stage", False)
		Endif
	EndEvent
EndState

State CustomAnimS10
	Event OnSelectST()
		Int Result = MainScr.CustomAnimSetStage(9)
		CustomAnimErrorMessageSetStage(Result)
	EndEvent
	Event OnHighlightST()
		SetInfoText("$Desc_SLTCAS")
	EndEvent
EndState
State CustomAnimSub10
	Event OnSelectST()
		If MainScr.CustomAnimSetSubStage(9)
			ForcePageReset()
		Else
			ShowMessage("$The corresponding animation for this stage need to be set before", False)
		Endif
	EndEvent
	Event OnHighlightST()
		SetInfoText("$Desc_SLTCASub")
	EndEvent
EndState
State CustomAnimST10
	Event OnSelectST()
		If MainScr.CustomAnimSetStageTimer(9)
			ForcePageReset()
		Else
			ShowMessage("$The corresponding animation for this stage need to be set before", False)
		Endif
	EndEvent
	Event OnHighlightST()
		SetInfoText("$Desc_SLTCAST")
	EndEvent
EndState
State CustomAnimStageRemove10
	Event OnSelectST()
		If MainScr.CustomAnimStageRemove(9)
			ForcePageReset()
		Else
			ShowMessage("$You can only remove the last stage", False)
		Endif
	EndEvent
EndState

Function CustomAnimErrorMessageSetStage(Int ErrorNum)
	If (ErrorNum == 1)
		ForcePageReset()
	Elseif (ErrorNum == 2)
		ShowMessage("$The name of the animation needs to be set before", False)
	Elseif (ErrorNum == 3)
		ShowMessage("$A stage previous to this one need to be set before", False)
	Elseif (ErrorNum == 4)
		ShowMessage("$No animations have been found for this configuration, check the race and/or the number of actors", False)
	Endif
EndFunction

Bool Function KeyConflict(Int newKeyCode, String conflictControl, String conflictName)
	Bool Continue = True
	If (newKeyCode == 1)
		newKeyCode = 0
		conflictControl = ""
	Endif
	If (conflictControl != "")
		string msg
		If (conflictName != "")
			msg = "This key is already mapped to: \n'" + conflictControl + "'\n(" + conflictName + ")\n\nAre you sure you want to continue?"
		Else
			msg = "This key is already mapped to: \n'" + conflictControl + "'\n\nAre you sure you want to continue?"
		Endif
		Continue = ShowMessage(msg, true, "$Yes", "$No")
	Endif
	Return !Continue
endFunction

State SystemReconfigure
	Event OnSelectST()
		MainScr.Install(True)
		ShowMessage("$Mod reconfigured", False)
	EndEvent
	Event OnHighlightST()
		SetInfoText("$Desc_POSSReconfigure")
	EndEvent
EndState
State ModifierKey
	Event OnKeyMapChangeST(int newKeyCode, string conflictControl, string conflictName)
		If !KeyConflict(newKeyCode, conflictControl, conflictName)
			ModifierKey = newKeyCode
			SetKeyMapOptionValueST(ModifierKey)
			MainScr.HKRefresh()
		Endif
	EndEvent
	Event OnDefaultST()
		ModifierKey = 44
		SetKeyMapOptionValueST(ModifierKey)
		MainScr.HKRefresh()
	endEvent
	Event OnHighlightST()
		SetInfoText("$Desc_ModifierKey")
	EndEvent
EndState
State ToolKey
	Event OnKeyMapChangeST(int newKeyCode, string conflictControl, string conflictName)
		If !KeyConflict(newKeyCode, conflictControl, conflictName)
			ToolKey = newKeyCode
			SetKeyMapOptionValueST(ToolKey)
			MainScr.HKRefresh()
		Endif
	EndEvent
	Event OnDefaultST()
		ToolKey = 35
		SetKeyMapOptionValueST(ToolKey)
		MainScr.HKRefresh()
	endEvent
	Event OnHighlightST()
		SetInfoText("$Desc_ToolKey")
	EndEvent
EndState
State ToolActorListKey
	Event OnKeyMapChangeST(int newKeyCode, string conflictControl, string conflictName)
		If !KeyConflict(newKeyCode, conflictControl, conflictName)
			ToolActorListKey = newKeyCode
			SetKeyMapOptionValueST(ToolActorListKey)
			MainScr.HKRefresh()
		Endif
	EndEvent
	Event OnDefaultST()
		ToolActorListKey = 35
		SetKeyMapOptionValueST(ToolActorListKey)
		MainScr.HKRefresh()
	endEvent
	Event OnHighlightST()
		SetInfoText("$Desc_ToolActorListKey")
	EndEvent
EndState
State ToolsOnlyKey
	Event OnKeyMapChangeST(int newKeyCode, string conflictControl, string conflictName)
		If !KeyConflict(newKeyCode, conflictControl, conflictName)
			ToolsOnlyKey = newKeyCode
			SetKeyMapOptionValueST(ToolsOnlyKey)
			MainScr.HKRefresh()
		Endif
	EndEvent
	Event OnDefaultST()
		ToolsOnlyKey = 0
		SetKeyMapOptionValueST(ToolsOnlyKey)
		MainScr.HKRefresh()
	endEvent
	Event OnHighlightST()
		SetInfoText("$Desc_ToolsOnlyKey")
	EndEvent
EndState
State CumOutsideKey
	Event OnKeyMapChangeST(int newKeyCode, string conflictControl, string conflictName)
		If !KeyConflict(newKeyCode, conflictControl, conflictName)
			CumOutsideKey = newKeyCode
			SetKeyMapOptionValueST(CumOutsideKey)
			MainScr.HKRefresh()
		Endif
	EndEvent
	Event OnDefaultST()
		CumOutsideKey = 0
		SetKeyMapOptionValueST(CumOutsideKey)
		MainScr.HKRefresh()
	endEvent
	Event OnHighlightST()
		SetInfoText("$Desc_CumOutsideKey")
	EndEvent
EndState
State ChangeStageKey
	Event OnKeyMapChangeST(int newKeyCode, string conflictControl, string conflictName)
		If !KeyConflict(newKeyCode, conflictControl, conflictName)
			ChangeStageKey = newKeyCode
			SetKeyMapOptionValueST(ChangeStageKey)
			MainScr.HKRefresh()
		Endif
	EndEvent
	Event OnDefaultST()
		ChangeStageKey = 0
		SetKeyMapOptionValueST(ChangeStageKey)
		MainScr.HKRefresh()
	endEvent
	Event OnHighlightST()
		SetInfoText("$Desc_ChangeStageKey")
	EndEvent
EndState
State UnregisterAnimation
	Event OnSelectST()
		MainScr.UnregisterAnimation()
		ForcePageReset()
	EndEvent
	Event OnHighlightST()
		SetInfoText("$Desc_SLTUnregisterAnimation")
	EndEvent
EndState
State QueueKey
	Event OnKeyMapChangeST(int newKeyCode, string conflictControl, string conflictName)
		If !KeyConflict(newKeyCode, conflictControl, conflictName)
			QueueKey = newKeyCode
			SetKeyMapOptionValueST(QueueKey)
			MainScr.HKRefresh()
		Endif
	EndEvent
	Event OnDefaultST()
		QueueKey = 0
		SetKeyMapOptionValueST(QueueKey)
		MainScr.HKRefresh()
	endEvent
	Event OnHighlightST()
		SetInfoText("$Desc_SLTQueueKey")
	EndEvent
EndState

State QueueAutoFollowPlayer
	Event OnSelectST()
		AutoFollowPlayer = !AutoFollowPlayer
		SetToggleOptionValueST(AutoFollowPlayer)
	EndEvent
	Event OnDefaultST()
		AutoFollowPlayer = True
		SetToggleOptionValueST(AutoFollowPlayer)
	EndEvent
	Event OnHighlightST()
		SetInfoText("$Desc_QueueAutoFollowPlayer")
	EndEvent
EndState
State QueueAutoFollowReceiver
	Event OnSelectST()
		AutoFollowReceiver = !AutoFollowReceiver
		SetToggleOptionValueST(AutoFollowReceiver)
	EndEvent
	Event OnDefaultST()
		AutoFollowReceiver = True
		SetToggleOptionValueST(AutoFollowReceiver)
	EndEvent
	Event OnHighlightST()
		SetInfoText("$Desc_QueueAutoFollowReceiver")
	EndEvent
EndState